<?php
    /*
    Plugin Name: Наценка на способ оплаты
    Plugin URI: http://www.shopos.ru/
    Version: 1.4
    Author:  shopos
    Author URI: http://www.shopos.ru/
    */

    add_action('page_admin', 'payment_add_page');
    add_action('page_admin', 'payment_remove_page');
    add_filter('checkout_payment_modules', 'checkout_payment_modules_filter') ;
    add_filter('checkout_alternative_modules', 'checkout_payment_modules_filter') ;
    add_filter('checkout_confirmation_order_total', 'checkout_confirmation_order_total_filter') ;
    add_action('order_total_process', 'order_total_process_func');

    function _round_price($price)
    {
        if ($price >= 50000) 
        {
            $price = ceil($price);    
        }
        else
        {   
            $price  = floor($price);
        }

        return $price;
    }

    function order_total_process_func()
    {
        if ( is_page('checkout_confirmation') or is_page('checkout_process') )
        {
            $payment_array = @unserialize ( get_option('payment') );


            if ( isset($payment_array[ @$_SESSION['payment'] ])) 
            {

                global $order_total_modules;
                global $order;
                global $order_total_array;
                global $osPrice;

                $total = $_SESSION['payment_rent_total_old'];

                $total_pro = $total*$payment_array[ @$_SESSION['payment'] ]['rate']/100 ;

                $total_pro = _round_price($total_pro);
                $order->info['total'] = _round_price( $total+$total_pro );  

                $GLOBALS['payment_rent'] = new payment_rent();

                $GLOBALS['payment_rent']->output[0]['title'] = 'Наценка на способ оплаты'; 
                $GLOBALS['payment_rent']->output[0]['sort_order'] = '50'; 
                $GLOBALS['payment_rent']->output[0]['text'] = $osPrice->Format($total_pro, true); 
                $GLOBALS['payment_rent']->output[0]['value'] = $total_pro; 

                if ( !in_array('payment_rent.php', $order_total_modules->modules) )
                {
                    $totals = preg_split('/;/', MODULE_ORDER_TOTAL_INSTALLED);


                    if ( $totals[  count($totals)-1 ] == 'ot_total.php' )
                    {
                        $totals[] = '';
                        $totals[ count($totals)-1 ] = $totals[ count($totals)- 2];
                        $totals[ count($totals)-2 ] = 'payment_rent.php';
                        $totals = array_unique($totals);
                        $totals = implode(';', $totals);
                        global $db;
                        $db->query('update '.DB_PREFIX.'configuration set configuration_value="'.$db->input($totals).'" where configuration_key = "MODULE_ORDER_TOTAL_INSTALLED"');
                    }

                    if ( $order_total_modules->modules[  count($order_total_modules->modules)-1 ] == 'ot_total.php' )
                    {
                        $order_total_modules->modules[] = '';
                        $order_total_modules->modules[ count($order_total_modules->modules)-1 ] = $order_total_modules->modules[ count($order_total_modules->modules)- 2];
                        $order_total_modules->modules[ count($order_total_modules->modules)-2 ] = 'payment_rent.php';
                    }

                }


            }
        }
    }

    function payment_install()
    {
        add_option('payment', '', 'readonly');
        global $db;
        $totals = preg_split('/;/', MODULE_ORDER_TOTAL_INSTALLED);


        if ( $totals[  count($totals)-1 ] == 'ot_total.php' )
        {
            $totals[] = '';
            $totals[ count($totals)-1 ] = $totals[ count($totals)- 2];
            $totals[ count($totals)-2 ] = 'payment_rent.php';
            $totals = array_unique($totals);
            $totals = implode(';', $totals);

            $db->query('update '.DB_PREFIX.'configuration set configuration_value="'.$db->input($totals).'" where configuration_key = "MODULE_ORDER_TOTAL_INSTALLED"');
        }

    }    

    function payment_remove()
    {
        global $db;
        $totals = preg_split('/;/', MODULE_ORDER_TOTAL_INSTALLED);


        if ( count($totals) > 0 )
        {
            $m = array();
            foreach ($totals as $num => $value)    
            {
                if ($value != 'payment_rent.php')
                {
                    $m[] = $value ; 
                }
            }
        }

        $totals = $m;
        $totals = array_unique($totals);
        $totals = implode(';', $totals);

        $db->query('update '.DB_PREFIX.'configuration set configuration_value="'.$db->input($totals).'" where configuration_key = "MODULE_ORDER_TOTAL_INSTALLED"');

    }

    class payment_rent
    {
        var $title = 'Наценка на способ оплаты';
        var $enabled = true;
        var $output = '';
        var $sort_order = '50';
        var $code = 'payment_rent';

        function process() {}
    }

    function payment_remove_page()
    {
        if ( isset($_GET['name']) && !empty($_GET['name']))
        {
            $payment_array = unserialize ( get_option('payment') );

            unset( $payment_array[ $_GET['name'] ]  );

            update_option( 'payment',  serialize($payment_array) );
        }

        os_redirect('plugins.php?module=payment&group=main');
    }

    function checkout_confirmation_order_total_filter($info)
    {
        unset($_SESSION['payment_rent_total_planc']);
        unset($_SESSION['payment_rent_total']);
        unset($_SESSION['payment_rent_total_old']);

        $payment_array = @unserialize ( get_option('payment') );

        global $osPrice;

        if ( isset($payment_array[ @$_SESSION['payment'] ]))
        {
            $total = $info['total'];

            $_SESSION['payment_rent_total_old']  = $total;

            if ( $payment_array[ $_SESSION['payment'] ]['rise'] == '-')
            {

                $GLOBALS['payment_rent_total']  = $osPrice->Format($total*$payment_array[ @$_SESSION['payment'] ]['rate']/100, true);
                $total = $total - $total*$payment_array[ @$_SESSION['payment'] ]['rate']/100 ;
                //  $total =  $osPrice->Format($total, false);
                $_SESSION['payment_rent_total_planc'] =  $total ;
                $_SESSION['payment_rent_total'] =  $GLOBALS['payment_rent_total'] ;

                if ( $total < 0 ) $total = 0;
            } 
            else
            {

                $GLOBALS['payment_rent_total']  = $osPrice->Format($total*$payment_array[ @$_SESSION['payment'] ]['rate']/100, true);
                $total = $total +$total*$payment_array[ $_SESSION['payment'] ]['rate']/100 ;  
                // $total =  $osPrice->Format($total, false); 
                $_SESSION['payment_rent_total_planc'] =  $total ;
                $_SESSION['payment_rent_total'] =  $GLOBALS['payment_rent_total'] ;
            }  

            $info['total'] = _round_price($total);  

        }    


        return $info;
    }

    function checkout_payment_modules_filter($array)
    {
        global $order;
        global $osPrice;
        unset($_SESSION['payment_rent_total_planc']);

        if ( !is_object($order)) $order = new order();
        if ( !is_object($osPrice)) $osPrice = new osPrice();

        $payment_array = unserialize ( get_option('payment') );

        foreach ($array as $id => $value)
        {
            if ( isset($payment_array[ $value['id'] ]))
            {
                $total = $order->info['total'];


                if ( $payment_array[ $value['id'] ]['rise'] == '-')
                {
                    $total = $total - $total*$payment_array[ $value['id'] ]['rate']/100 ;
                    if ( $total < 0) $total = 0;
                } 
                else
                {
                    $total = $total + $total*$payment_array[ $value['id'] ]['rate']/100 ;   
                }   

                $total = _round_price($total);
                $total = $osPrice->Format($total, true);

                $array[$id]['module']  = $array[$id]['module'] . ' <font color="red">('.$total.')</font>'; 
            }
        }

        return    $array;
    }

    function payment_add_page()
    {

        $payment_array = unserialize ( get_option('payment') );

        $payment_array[ $_POST['payment']['name']]  = array('rise' =>  $_POST['payment']['rise'], 'rate' =>  (float)$_POST['payment']['rate']);

        update_option( 'payment',  serialize($payment_array) );
        os_redirect('plugins.php?module=payment&group=main');
    }

    function get_payment_installed()
    {
        $directory_array = array();
        $m_install = array();

        if ($dir = opendir( dir_path('payment') )) 
        {

            while ($file = readdir($dir))
            { 
                if ( is_dir( dir_path('payment') . $file) && $file != '.' && $file != '..' && $file != '.svn') 
                {
                    $directory_array[] = $file;
                }
            }
            sort($directory_array);
            closedir($dir);


            if ( count($directory_array) > 0 )
            {
                foreach ($directory_array as $value)
                {
                    if ( is_file( dir_path('payment') .  $value . '/'. $value.'.php') )
                    {
                        include( dir_path('payment') .  $value . '/'. $value.'.php' );

                        if (os_class_exists($value)) 
                        {
                            $module = new $value();
                            if ( $module->check() >= 1 )
                            {
                                $m_install[] =  $value;
                            } 
                        }
                    }
                }
            }

        }

        return $m_install;
    }

    function payment_readonly()
    {
        $payment_array = get_payment_installed();
        if ( count($payment_array) > 0 )
        {
            echo '</form>';
            echo '<form action="'.page_admin('payment_add_page').'" method="post">';
            echo '<table width="100%" border="0"><tr>';

            echo '<tr style="font-weight:bold;text-align:center;font-size: 9px;" >';
            echo '<td>модуль</td>';
            echo '<td>+/-</td>';
            echo '<td>%</td>';
            echo '</tr>';


            echo '<td valign="top">';
            echo '<select class="round" name="payment[name]" style="width:80px;">';
            foreach ( $payment_array as $value)
            {
                echo '<option>'.$value.'</option>';
            }

            echo '<td valign="top"><select class="round" name="payment[rise]" style="width:40px;"><option selected>+</option><option>-</option></select></td>';



            echo '</select>';
            echo '</td>';

            echo '<td valign="top"><input  class="round" name="payment[rate]" style="width:80%" type="text" value=""></td>';
            echo '</tr></table>';

            echo '<input name="" type="submit" value="Добавить">';

            echo '</form>';

            $array = unserialize ( get_option('payment') );
            if ( is_array($array) &&  count($array) > 0 )
            {
                echo '<br /><br>';
                echo '<table width="100%" border="0">';

                foreach ($array as $name => $val)
                {

                    echo '<tr style="text-align:center;">';
                    echo '<td>'.$name.'</td>';
                    echo '<td>'.$val['rise'].$val['rate'].'%</td>';
                    echo '<td><a href="'.page_admin('payment_remove_page').'&name='.$name.'"><font color="red"><b>X</b></font></a></td>';
                    echo '</tr>';
                }

                echo '</table>';
            }


        }
        else
        {
            echo 'нет установленных модулей оплаты.';
        }
    }
?>